#ifndef PARTICLE_H
#define PARTICLE_H

#include "list.h"

typedef float VECTOR[3];

class CPartEmitter;

class CParticle  
{
public:
	CParticle(CPartEmitter* pEmitter);
	virtual ~CParticle();
	void Update();
	void Render();
public:
	VECTOR m_vPosition;		// Position
	VECTOR m_vVelocity;		// Geschwindigkeit
	float	 m_clrColor[4];	// Farbe
	float	 m_fSize;				// Groesse
	float  m_fBirthday;		// Zeitpunkt der Geburt
	float  m_fLifetime;		// Lebenspanne
	bool	 m_bLife;				// wird vom Emitter gelscht falls false
	float  m_fChangeSize;	// *NEU* Grennderung
	bool	 m_bChangeSize;	// *NEU* bei true wird die Gre des Partikels gendert
	float  m_fMaxSize;		// *NEU* maximale Gre
	float	 m_clrChangeColor[4]; // *NEU*Farbnderung
	bool	 m_bBorn;				// *NEU* true: Partikel wird "geboren"
	bool	 m_bIsDying;		// *NEU* true: Partikel loest sich auf
	float  m_fFadeSpeed;	// *NEU* so schnell verschwindet ein Partikel
	float  m_fFadeInSpeed;// *NEU* so schnell erscheint ein Partikel
		
	void Set(VECTOR vPosition,VECTOR vVelocity, float clrColor[4],float clrChangeColor[4],
					 float fSize,float fChangeSize,float fLifetime,float fFadeSpeed);

	CParticle* GetNext();
	void SetNext(CParticle* pNext);
private:
	CPartEmitter* m_pEmitter;
	CParticle* m_pNext;
};

class	CParticleList : public CList<CParticle*> {};

inline CParticle* CParticle::GetNext() {return m_pNext;}
inline void CParticle::SetNext(CParticle* pNext) {m_pNext = pNext;}


#endif // PARTICLE_H
